/*
------------------------------------------------------------
Copyright ) 1989 Rob Kassel, Mike McCandless and the Massachusetts Institute of Technology

Permission to use, copy, modify, and distribute this software and its documentation for any purpose without fee is hereby granted, provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice appear in supporting documentation, and that the name of M.I.T. not be used in advertising or publicity pertaining to distribution of the software without specific, written prior permission.  The authors and M.I.T. make no representations about the suitability of this software for any purpose.  It is provided Ras isS without express or implied warranty.
------------------------------------------------------------
*/

#include "ctype.h"
#include "fcntl.h"
#include "errno.h"
#include "sys/types.h"
#include "sys/stat.h"
#include "string.h"
#include "dirent.h"
#include "stdio.h"
#include "memory.h"



/*quemail's constants*/

#define MAXMSGLENGTH 20000	/*Characters long before it is divided...*/

#define aYearInS 31536000
#define MAXNAME 255
#define aFROM "From:"
#define aRPLTO "Reply-To:"
#define SUBJECT "Subject:"
#define theDir "/usr/maildrops"
#define theSpace " \0"
#define MSGHDR "m"
#define FALSE 0
#define TRUE !0
#define dropChar 'd'
#define userChar 'u'
#define MAXLINE 1000

#define spcl    1       /*special char: @ . , */
#define atm     2       /*an atom; just a word, etc*/
#define cmnt    3       /*a comment in ()'s*/
#define addrS   4       /*like this: <akjdk.adkfj@kjdf.asfd>*/
#define atAtm   5       /*like this: kajsdfjasdjf.asdkfl@kajsflk.ajsdlfj*/
#define colAtm  6       /*like this: alkdjfljas dflsajf:lajsfjfja*/
#define commaAtm 7	/*A comma, alone and single*/


/*getmsg constants*/



#define TOREAD "readMsg"
#define MSGHDR "m"



struct fld {
        int cnt;                /*Holds the number of items found in field*/
        char buf[MAXLINE];      /*Holds the orig. text of field*/
        struct fldItem {
                char *txt;
                int tpe;
        }       itm[50];         /*Holds each item description*/
};


/*Memory module for storing text stuff*/


struct memBuf {
  int segSze;
  int maxSegs;
  int curSeg;
  char **memPtrs;
  char *curPtr;
  char *playBackPtr;
  int playBackSeg;
} *allocBuf();
	

/*String routines*/

char *getline(),*flp(),*fltr();
char *alcCh();
char *makeLower(),*rmSpce();
char *strchr();
char *getNextFile();
char *readAdress(),*formatIt();
char *alter(),*interpret();
char errBuf[200];
char *parseReplyTo(),*encode();
char *strp1Ch();
char *hdrLnPtrs[MAXLINE];
char *sys_errlist[];
char *getPtr(),*calloc();
int errno;

FILE *fopen();
long time();


char *getline(s,n)

char *s;
int n;
{
        int c;
        char *cs;

        cs = s;
        while (--n > 0 && (c = getchar()) != EOF)
                if((*cs++ = c) == '\n')
                        break;
        if (n<=0)
                printf("Data lost: line > %d characters.\n",n);

        *cs = '\0';
        return((c == EOF && cs == s) ? NULL : s);
}

char* flp(s)

char* s;

{
int x,lp;
char* c;

x = strlen(s);
c = (char*) malloc(x * sizeof(char));
if (c == NULL) {
        sprintf(errBuf,"Out of memory.\n");
        errorParser(errBuf);
}

for(lp=0;lp<x;lp++)
        c[lp] = s[x - lp - 1];


c[x] = 0;
return(c);
}


char* fltr(s)

char *s;
{
int x,lp;

x = strlen(s);
for(lp=0;lp<x;lp++)
        if (*(s + lp) == '.' || *(s + lp) == '/')
                *(s + lp) = '0';

return(s);
}



char* rmSpce(s)

char *s;
{
char *m;

m = alcCh(strlen(s));
strcpy(m,s);

while(*m == (char)32 || *m == (char) 9 || *m == (char) 10)
        m++;

while(*(m + strlen(m) - 1) == (char) 32 || *(m + strlen(m) - 1) == (char) 9 || *
(m + strlen(m) - 1) == (char) 10)
        *(m + strlen(m) - 1) = 0;


return(m);
}


char* makeLower(s)

char *s;
{
int x,lp;

x = strlen(s);
for (lp = 0; lp < x; lp++)
        if (isupper(*(s + lp)))
                *(s + lp) = tolower(*(s + lp));
return(s);
}

int fileThere(name)

char *name;

{
DIR *dirp;
struct dirent *dp;

dirp = opendir(".");
if (dirp == NULL) {
	sprintf(errBuf,"Can't open directory.");
	errorParser(errBuf);
}

for (dp = readdir(dirp); dp != NULL; dp = readdir(dirp))
    if (!strcmp(dp->d_name, name)) {
         closedir (dirp);
         return(1);
    }

closedir (dirp);
return(0);
}


char* alter(buf,theC)

char *buf;
char theC;

{
char ch,c;
char *pBuf;
char buf2[MAXLINE],*pBuf2;
char buf3[MAXLINE + 5];
int aSpce;
int n,x,y;

pBuf = buf;
n = 0;

pBuf = (char*) rmSpce(buf);

x = strlen(pBuf);
y = 0;

while(y < x) {
        if (*(pBuf + y) == (char) 9 ||  *(pBuf + y) == (char) 10)
                *(pBuf + y) = (char) 32;
        y++;
}

y = 0;
c = 0;
aSpce = FALSE;
pBuf2 = buf2;

while (y < x) {
        if (*(pBuf + y) != 32) {
                *(pBuf2 + c) = *(pBuf + y);
                c++;
                aSpce = FALSE;
        }
        else
                if (!aSpce) {
                        *(pBuf2 + c) = *(pBuf + y);
                        aSpce = TRUE;
                        c++;
                }
        y++;
}

*(pBuf2 + c) = 0;


y = 0;
x = strlen(pBuf2);

while (y < x)  {
        if (*(pBuf2 + y) == ' ')   *(pBuf2 + y) = theC;
        y++;
}

if (*(pBuf2 + strlen(pBuf2) - 1) == ':') *(pBuf2 + strlen(pBuf2) - 1) = '\0';
return(pBuf2);
}




errorParser(msg)

char *msg;

{
fprintf(stderr,"%s\n",msg);
exit(1);

/*This must complain about the error, save the message as best it can, and*/
/*exit; terminate with extreme prejudice*/
}


fieldParse(pF)

struct fld *pF;

{
/*This procedure will be given all the text after the : in an unfolded line*/
/*It must decipher it into its constituent parts*/

char *m;
int cnt,cnt2,lp,touched;
char ch;


m = rmSpce(pF->buf);
cnt = 0;

while (*m != '\0') {
        touched = FALSE;

        if (*m == 40) {
                touched = TRUE;
                pF->itm[cnt].txt = (char*) (m + 1);
                pF->itm[cnt].tpe = cmnt;
                cnt++;
                m++;
                while(TRUE) {
                        ch = *m;
                        if (ch == (char)41 || ch == (char)0)
                                break;
                        m++;
                }

                if (*m == 0) {
                        printf("Unbalanced paren.\n");
                        exit(1);
                }
                if (*m == 41)
                        *m = '\0';
                m++;
		if (*m == ',') {
			pF->itm[cnt].txt = '\0';
			pF->itm[cnt].tpe = commaAtm;
			m+=1;
		}
        }

        if (*m == 60) {
                touched = TRUE;
                pF->itm[cnt].txt = (char*) (m + 1);
                pF->itm[cnt].tpe = addrS;
                cnt++;
                m++;
                while(TRUE) {
                        ch = *m;
                        if (ch == (char)62 || ch == (char)0)
                                break;
                        m++;
                }

                if (*m == 0) {
                        printf("Unbalanced paren.\n");
                        exit(1);
                }
                if (*m == 62)
                        *m = '\0';
                m++;
		if (*m == ',') {
			pF->itm[cnt].txt = '\0';
			pF->itm[cnt].tpe = commaAtm;
			m+=1;
		}
	}

        if (!touched && !(*m == 32 || *m == 9)) {
                touched = TRUE;
                pF->itm[cnt].txt = (char*) m;
                pF->itm[cnt].tpe = atm;
                cnt++;
                m++;
                while(TRUE) {
                        ch = *m;
                        if (ch == (char)32 || ch == (char)0 || ch ==(char) 9)
                                break;
                        m++;
                        if (ch == '@' || ch == '!')
                                pF->itm[cnt - 1].tpe = atAtm;
                }

                if (*m == 32 || *m == 9)
                        *m = '\0';
                m++;
        }

        if (!touched)
                m++;
}

pF->cnt = cnt;
}


char* alcCh(sze)

int sze;

{
char *p;

p = (char*) malloc(sze * sizeof(char));
if (p==NULL) {
	sprintf(errBuf,"Out of memory.");
	errorParser(errBuf);
}
else
	return(p);
}


char* strp1Ch(s)

char *s;

{
*(s + strlen(s) - 1) = '\0';
return(s);
}




/*Memory managament procedures...*/

resetBuf(theBuf)

struct memBuf *theBuf;

{
  theBuf->playBackPtr = theBuf->memPtrs[0];
  theBuf->playBackSeg = 0;
}





struct memBuf *allocBuf(segSze,maxSegs)

int segSze,maxSegs;

{
struct memBuf *thePtr;


thePtr = (struct memBuf *) getPtr(sizeof(struct memBuf));
thePtr->maxSegs = maxSegs;
thePtr->segSze = segSze;
thePtr->memPtrs = (char**) getPtr(maxSegs*sizeof(char*));
thePtr->curSeg = 0;
thePtr->memPtrs[0] = getPtr(segSze);
thePtr->curPtr = thePtr->memPtrs[0];
thePtr->playBackPtr = thePtr->curPtr;
thePtr->playBackSeg = 0;

return(thePtr);
}




storeStr(str,bufPtr)

char *str;
struct memBuf *bufPtr;

{
int lng = strlen(str) + 1;
int charR;


while (lng > 0) {
  charR = bufPtr->segSze - (bufPtr->curPtr - bufPtr->memPtrs[bufPtr->curSeg]);

  if (lng < charR) {
    strcpy(bufPtr->curPtr,str);
    bufPtr->curPtr += lng;
    break;
  }

  if (lng == charR) {
    strcpy(bufPtr->curPtr,str);
    bufPtr->curSeg++;
    bufPtr->memPtrs[bufPtr->curSeg] = getPtr(bufPtr->segSze);
    bufPtr->curPtr = bufPtr->memPtrs[bufPtr->curSeg];
    break;
  }
  
  if (lng > charR) {
    strncpy(bufPtr->curPtr,str,charR);
    lng -= charR;
    str += charR;
    bufPtr->curSeg++;
    bufPtr->memPtrs[bufPtr->curSeg] = getPtr(bufPtr->segSze);
    bufPtr->curPtr = bufPtr->memPtrs[bufPtr->curSeg];
  }
}

return(1);
}




readStr(buf,bufPtr)

char *buf;
struct memBuf *bufPtr;

{
char *tP=buf;
char *trackP = bufPtr->playBackPtr;


if (*trackP == 0) {
  *buf = 0;
  return(0);
}

while (*trackP != 0) {
  *tP++ = *trackP++;
  if (trackP == bufPtr->memPtrs[bufPtr->playBackSeg] + bufPtr->segSze) {
    bufPtr->playBackSeg++;
    trackP = bufPtr->memPtrs[bufPtr->playBackSeg];
  }
}

*tP = 0;
bufPtr->playBackPtr = trackP+1;
return(1);
}



char *getPtr(sze)

int sze;

{
char *ptr;

ptr = calloc(sze,sizeof(char));

if (ptr == NULL) {
	errorParser("Out of memory.\n");
	exit(1);
}
return(ptr);
}
