/*
------------------------------------------------------------
Copyright ) 1989 Rob Kassel, Mike McCandless and the Massachusetts Institute of Technology

Permission to use, copy, modify, and distribute this software and its documentation for any purpose without fee is hereby granted, provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice appear in supporting documentation, and that the name of M.I.T. not be used in advertising or publicity pertaining to distribution of the software without specific, written prior permission.  The authors and M.I.T. make no representations about the suitability of this software for any purpose.  It is provided Ras isS without express or implied warranty.
------------------------------------------------------------
*/

#include "mail.h"

struct {
	int num;
	char nme[20][40];
} theHdrFilter;


char tBuf[MAXLINE];
char *hdrLnPtrs[MAXLINE];
FILE *fpOut, *fpTemp;
char glbBuf[MAXLINE];
int glbFlag;
struct memBuf *myMemory;

main(argc,argv) 
int argc;
char *argv[];

{
char pLine[MAXLINE],pName[20],*aBuf;
char dirName[255];
int done,nxtMsg,nxtRdMsg,lineNum,fd;
time_t t;
char tme[15];
char nme[255];
char mailDropName[MAXNAME],theUserName[MAXNAME];
int numChars = 0;
int msgPart = 2;		/*Start with a second part to the message*/



/*analyze on-line arguments*/

Init();
parseArgs(argc,argv,mailDropName,theUserName,argv[0]);


myMemory = allocBuf(MAXLINE,100);

/*Now I must find a unique file name, based on the time...*/
fd = createUniqFile(argv[0],nme,mailDropName);

fpOut = fopen(nme,"w");
if (fpOut == NULL) {
	strcpy(errBuf,"Can't open mail file.\n");
	errorParser(errBuf);
}
chmod(nme,0666);


sprintf(tBuf,"X-Mac-To: %s\n",theUserName);
storeStr(tBuf,myMemory);
fprintf(fpOut,"X-Mac-To: %s\n",theUserName);


/*Now, I must interpret the mail header..*/
lineNum = 0;
done = FALSE;
getline(pLine,MAXLINE);	/*Gets rid of From *** Unix 1st line*/


while (getline(pLine,MAXLINE) != NULL) {
	if (done) {		/*Done reading the header*/
		fputs(pLine,fpOut);
		numChars+=strlen(pLine)+1;
		if (numChars >= MAXMSGLENGTH) {
			close(fd);
			fclose(fpOut);

			fd = createUniqFile(argv[0],nme,mailDropName);

			fpOut = fopen(nme,"w");
			if (fpOut == NULL) {
				strcpy(errBuf,"Can't open mail file.\n");
				errorParser(errBuf);
			}
			chmod(nme,0666);
			dumpAnotherHeader(fpOut,msgPart);
			msgPart++;
			numChars = 0;
		}
	}

	else {
		if (strlen(pLine) == 1 && (int) pLine[0] == 10) {
/*A blank line indicates the beginning of the body*/
			dealWithHeader(lineNum);
			fprintf(fpOut,"\n");
			storeStr("\n",myMemory);
			done = TRUE;	
		}
		aBuf = alcCh(MAXLINE);
		strcpy(aBuf,pLine);
		hdrLnPtrs[lineNum] = aBuf;	
		lineNum++;
		if (lineNum == MAXLINE) {
			strcpy(errBuf,"Mail header too long.\n");
			errorParser(errBuf);
		}
	}
}

close(fd);
fclose(fpOut);
}



dumpAnotherHeader(fpOut,partNum)

FILE *fpOut;
int partNum;

{
char lne[MAXLINE];
char buf[30];
int foundIt = FALSE;



resetBuf(myMemory);

while(readStr(lne,myMemory) != 0) {
	if (!strncmp(lne,SUBJECT,strlen(SUBJECT))) {
		foundIt = TRUE;
		sprintf(buf," (Part %d)\n",partNum);	
		strp1Ch(lne);
		strcat(lne,buf);	
		fprintf(fpOut,lne);
                buf[0] = NULL;
	      }

	else 
		if ((strlen(lne) == 1) && (*lne == 10) && !foundIt) {
			fprintf(fpOut,"Subject: Continued Message (Part %d)\n",
				partNum);
			fprintf(fpOut,lne);
		      }
		else  fprintf(fpOut,lne);
      }
}




createUniqFile(progName,nme,mailDropName)

char *progName,*nme,*mailDropName;


{
char tme[15];
time_t t;
int fd;
char dirName[MAXLINE];



sprintf(dirName,"%s/%s",theDir,mailDropName);

t = time((time_t *)0);
t = t % aYearInS;

while(1) {
	sprintf(tme,"%s",fltr(encode((long)t)));
	sprintf(nme,"%s/%s%s",dirName,MSGHDR,tme);

	fd = open(nme,O_WRONLY+O_EXCL+O_CREAT,S_IRUSR+S_IWUSR+S_IRGRP+S_IWGRP);

	if (fd == -1 && errno != EEXIST && errno != ENOENT) {
		sprintf(errBuf,"%s: %s\n",progName,sys_errlist[errno]);
		errorParser(errBuf);
	}

	if (fd == -1 && errno == ENOENT) {
		sprintf(errBuf,"No such mail drop %s.\n",mailDropName);
		errorParser(errBuf);
	}

	if (fd == -1 && errno == EEXIST)
		t++;

	if (fd != -1)
		break;
}

return(fd);
}






dealWithHeader(numLines) 
int numLines;

{
int lp,foldCount,unFoldCount;
char buf[MAXLINE],ch,c;
char *unFold[MAXLINE],*pS;


/*Parse the entire header, extracting what I need*/

foldCount = 0;
unFoldCount = -1;


while (foldCount < numLines) {
	ch = *hdrLnPtrs[foldCount];	/*The first char of the line*/
	if ((int)ch != 32 && (int)ch != 9) {
		unFoldCount++;
		unFold[unFoldCount] = alcCh(MAXLINE);
		strcpy(unFold[unFoldCount],hdrLnPtrs[foldCount]);
		strp1Ch(unFold[unFoldCount]);
	}
	else {
		strcat(unFold[unFoldCount],hdrLnPtrs[foldCount]);
		strp1Ch(unFold[unFoldCount]);
		if(strlen(unFold[unFoldCount]) >= MAXLINE)
			printf("Unfolded line too long; data lost.\n");
	}
	foldCount++;

}


glbFlag = 0;
lp = 0;

for (lp=0;lp<=unFoldCount;lp++)  {
	parseHdrLine(unFold[lp],0);
}

fprintf(fpOut,"%s",glbBuf);
storeStr(glbBuf,myMemory);

for (lp=0;lp<=unFoldCount;lp++) 
	parseHdrLine(unFold[lp],1);

}


parseHdrLine(pLne,mde)

char* pLne;
int mde;

{
int lp,allow;
char mailBx[MAXLINE];
char buf[MAXLINE + 20];

allow = TRUE;


/*I need to look for From:
		     Reply To:
    to create the the X-Mac-From: field in the Mac's message file.
*/


if (!glbFlag && !mde)  {
	if (strncmp(pLne,aRPLTO,strlen(aRPLTO)) == 0) {
		strcpy(mailBx,rmSpce(pLne+strlen(aRPLTO)));
		sprintf(glbBuf,"X-Mac-From: %s\n",parseReplyTo(mailBx));	
		glbFlag = 1;
	}
	else
		if (strncmp(pLne,aFROM,strlen(aFROM)) == 0) {
			strcpy(mailBx,rmSpce(pLne + strlen(aFROM)));
			sprintf(buf,"X-Mac-From: %s\n",parseReplyTo(mailBx));	
			strcpy(glbBuf,buf);
		}
}


for(lp=0;lp<theHdrFilter.num;lp++)
	if (!strncmp(pLne,theHdrFilter.nme[lp],strlen(theHdrFilter.nme[lp]))) {
		allow = FALSE;
		break;
	}


if (allow && mde) {
	sprintf(tBuf,"%s\n",pLne);
	storeStr(tBuf,myMemory);
	fprintf(fpOut,"%s\n",pLne);
}
}


parseArgs(argc,argv,drop,user,progName)

int argc;
char *argv[];
char *drop,*user;
char *progName;

{
int lp;
int errr;
char buf[MAXNAME],ch;

errr = FALSE;
*user = (char)0;
*drop = (char)0;

for(lp=1;lp<argc;lp++) {
	if (*argv[lp] != '-') {
		errr = TRUE;
	}
	else {
		ch = *(argv[lp] + 1);
		if (ch == 0) {
			errr = TRUE;
			break;	
		}
		if (ch != dropChar && ch != userChar) {
			errr = TRUE;
			break;
		}

		if(ch == dropChar) {
			if (*drop != 0) {
				errr = TRUE;
				break;
			}
			if (strlen(argv[lp]) == 2) {
				strcpy(buf,argv[lp + 1]);
				lp++;
			}
			else
				strcpy(buf,argv[lp] + 2);
			
			strcpy(drop,makeLower(buf));
			if(*buf == '-')
				errr = TRUE;
		}
		
		if(ch == userChar){
			if (*user != 0) {
				errr = TRUE;
				break;
			}

			strcpy(buf,"\0");
			if (strlen(argv[lp]) > 2) {
				strcpy(buf,argv[lp] + 2);
				strcat(buf,theSpace);
			}
				
			lp++;
			if(lp < argc) 
			    while(*argv[lp] != '-' && lp < argc) {
				strcat(buf,argv[lp]);
				if((lp+1) < argc)
				    if((*argv[lp+1] != '-'))
					strcat(buf,theSpace);
				lp++;
				if (lp == argc)
					break;
			    }

			if (lp != argc) lp--;
			
			strcpy(user,buf);
			if(*buf == '-')
				errr = TRUE;
		}
	}
}

if (errr || *user == (char)0 || *drop == (char)0) {
	sprintf(errBuf,"Usage: |%s -%c maildrop -%c username.\n",progName,dropChar,userChar);
	errorParser();
}
}


char* encode(y)

long y;

{
/*encode a long number into a base-36 format*/
/*0...9,A....Z*/
int z,m;
char *c;

c = alcCh(MAXLINE);

m = 0;
while (y>0) {
        z = y % 36;
        y -= z;
        y /= 36;
        if (z > 9)
                *(c+m) = (char) z + 55;
        else
                *(c + m) = (char) z + 48;
        m++;
}

*(c+m) = (char)0;
return(flp(c));
}






Init() {
	
char buf[1000];


	theHdrFilter.num = 6;
	strcpy(theHdrFilter.nme[0],"Return\0");
	strcpy(theHdrFilter.nme[1],"Received\0");
	strcpy(theHdrFilter.nme[2],"Message-Id\0");
	strcpy(theHdrFilter.nme[3],"Apparently\0");
	strcpy(theHdrFilter.nme[4],"Status\0");
	strcpy(theHdrFilter.nme[5],"Mail\0");
	
	/*scanf("%[^\n]%*c",buf);*/
}



char* parseReplyTo(msg)

char *msg;
{
struct fld fldRp,*pFldRp;
int lp,lp1;
int tpe,contin;
char *x;
struct {
	char adr[MAXLINE];
	char phr[MAXLINE];
}	xmFormat;	/*Mac's format: phr <adr>\n*/
char tBuf[MAXLINE];
char *pBuf;
char *buf;
int canCmnt;


buf = alcCh(MAXLINE); 

pFldRp = &fldRp;

strcpy(pFldRp->buf,msg);
fieldParse(pFldRp);


/*
struct fld {
        int cnt;                /Holds the number of items found in field/
        char buf[MAXLINE];      /Holds the orig. text of field/
        struct fldItem {
                char *txt;
                int tpe;
        }       itm[50];         /Holds each item description/
};
*/


*xmFormat.adr = '\0';
*xmFormat.phr = '\0';

for(lp=0;lp<pFldRp->cnt;lp++)
	if (pFldRp->itm[lp].tpe == addrS) {
		sprintf(xmFormat.adr,"<%s>",pFldRp->itm[lp].txt);
		break;
	}

if (!strlen(xmFormat.adr)) {
	for(lp=0;lp<pFldRp->cnt;lp++)
		if (pFldRp->itm[lp].tpe == atAtm) {
			sprintf(xmFormat.adr,"<%s>",pFldRp->itm[lp].txt);
			break;
		}
}

else
	for(lp=0;lp<pFldRp->cnt;lp++)
		if (pFldRp->itm[lp].tpe == atAtm) {
			sprintf(xmFormat.phr,"%s",pFldRp->itm[lp].txt);
			break;
		}
	


if (!strlen(xmFormat.phr))
	for(lp=0;lp<pFldRp->cnt;lp++)
		if (pFldRp->itm[lp].tpe == cmnt) {
			sprintf(xmFormat.phr,"%s",pFldRp->itm[lp].txt);
			break;
		}

if (!strlen(xmFormat.phr))
	pBuf = xmFormat.phr;
else
	pBuf = tBuf;

contin = 1;
for (lp1=0;lp1<pFldRp->cnt;lp1++)  {
	if (!contin)
		break;
	if (pFldRp->itm[lp1].tpe == atm) {
		contin = 0;
		lp = 0;
		while(pFldRp->itm[lp + lp1].tpe == atm) {
			strcat(pBuf,pFldRp->itm[lp + lp1].txt);
			strcat(pBuf," \0");
			lp++;
			if (lp + lp1 == pFldRp->cnt) break;
		}
		strp1Ch(pBuf);
	}
}

if (!strlen(xmFormat.adr) && strlen(tBuf))
	sprintf(xmFormat.adr,"<%s>",tBuf);

if (!strlen(xmFormat.adr) && strlen(xmFormat.phr))
	sprintf(xmFormat.adr,"<%s>",xmFormat.phr);

if (!strlen(xmFormat.phr) && strlen(xmFormat.adr)) {
	strncpy(xmFormat.phr,xmFormat.adr + 1,strlen(xmFormat.adr) - 2);
	*(xmFormat.phr + strlen(xmFormat.adr) - 2) = 0;
}
	
sprintf(buf,"%s %s",xmFormat.phr,xmFormat.adr);
return(buf);
}
