/*
------------------------------------------------------------
Copyright  1989 Rob Kassel, Mike McCandless and the Massachusetts Institute of Technology

Permission to use, copy, modify, and distribute this software and its documentation for any purpose without fee is hereby granted, provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice appear in supporting documentation, and that the name of M.I.T. not be used in advertising or publicity pertaining to distribution of the software without specific, written prior permission.  The authors and M.I.T. make no representations about the suitability of this software for any purpose.  It is provided as is without express or implied warranty.
------------------------------------------------------------
*/

#include "mail.h"
#define BUFSZE 5000

char theFrom[MAXLINE];
char adress[MAXLINE];
int ptrCnt=0,chrCnt=0;
FILE *fpBBuf;
char* bufPtrs[MAXLINE];

main(argc,argv) 
int argc;
char *argv[];

{
char pLine[MAXLINE],pName[20],*aBuf;
char sndMl[MAXLINE];
int done,nxtMsg,nxtRdMsg,lineNum;
int Mode;

Mode = FALSE;
*theFrom = '\0';

if (argc > 2) {
	printf("Usage: %s [-a]\n",argv[0]);
	exit(1);
}


if (argc == 2)
	if (strcmp(argv[1],"-a")) {
		printf("Usage: %s [-a]\n",argv[0]);
		exit(1);
	}
	else
		Mode = TRUE;	

	
bufPtrs[0] = (char*) malloc(BUFSZE * sizeof(char));
if (bufPtrs[0] == NULL) {
	printf("Out of memory.\n");
	exit(1);
}
*(bufPtrs[0]) = '\0';


if (!Mode) {
	fpBBuf = fopen("bodbuf","w");
	if (fpBBuf == NULL) {
		printf("Couldn't open buffer file.\n");
		exit(1);
	}
}

strcpy(adress,readAdress());

if (!Mode) {
	readHdr();
	putline(adress);
	putline("\n\0");

	while (getline(pLine,MAXLINE) != NULL)
		sendCorrected(pLine);

	fclose(fpBBuf);
}

else {
	printf("Sending copy...\n");
	transcribe(adress);
}

writePipe();
}




sendCorrected(pLine)

char pLine[MAXLINE];
{
char lineCp[MAXLINE];

/*All checking occurs here!!*/

strncpy(lineCp,pLine,MAXLINE);

if (strncmp("From ",lineCp,5) == 0) {
	lineCp[0] = '>';
	lineCp[1] = '\0';
	strncat(lineCp,pLine,MAXLINE-2);
	if (strlen(lineCp) >= MAXLINE)
		printf("Warning: line too long, data was lost.");
}

putline(lineCp);
fputs(lineCp,fpBBuf);
}




char* readAdress() {

char ch,c;
char buf[MAXLINE],*pBuf;
char buf2[MAXLINE],*pBuf2;
char buf3[MAXLINE + 5];
int aSpce;
int n,x,y;

pBuf = buf;
n = 0;

while(n < MAXLINE && (c=getchar()) != (char)12) {
	*pBuf++ = c;
	n++;
}
	
c = getchar();

if (n == MAXLINE) 
	printf("Data lost in address.\n");

*pBuf = '\0';


pBuf = rmSpce(buf);

x = strlen(pBuf);
y = 0;

while(y < x) {
	if (*(pBuf + y) == (char) 9 ||  *(pBuf + y) == (char) 10)
		*(pBuf + y) = (char) 32;
	y++;
}



y = 0;
c = 0;
aSpce = FALSE;
pBuf2 = buf2;

while (y < x) {
	if (*(pBuf + y) != 32) {
		*(pBuf2 + c) = *(pBuf + y); 
		c++;
		aSpce = FALSE;
	}
	else
		if (!aSpce) {
			*(pBuf2 + c) = *(pBuf + y);
			aSpce = TRUE;
			c++;
		}	
	y++;
}

*(pBuf2 + c) = 0;


y = 0;
x = strlen(pBuf2);

while (y < x)  {
	if (*(pBuf2 + y) == ' ')   *(pBuf2 + y) = '.';
	y++;
}

sprintf(buf3,"To: %s\n",pBuf2);
return(buf3);
}





readHdr() {

FILE *fpBuf;
char pLine[MAXLINE];

fpBuf = fopen("hdrbuf","w");

if (fpBuf == NULL) {
	printf("Couldn't open buffer file.\n");
	exit(1);
}


while (strlen(getline(pLine,MAXLINE)) != 1) {
	if(!strncmp(pLine,"From:",5)) {
		fputs(formatIt(pLine),fpBuf);
		putline(formatIt(pLine));
		strcpy(theFrom,formatIt(pLine) + 6);
		*(theFrom + strlen(theFrom) - 1) = '\0';
	}
	else {
		fputs(pLine,fpBuf);
		putline(pLine);
	}
}

fprintf(fpBuf,"-*-%s\n",theFrom);
fclose(fpBuf);
}


char* formatIt(s)

char* s;

{
char *m;
char *t;


t = alcCh(MAXLINE); 
m = (char*) (s + 6);
m = alter(rmSpce(m),'_');
sprintf(t,"From: %s\n",m);

return(t);
}


transcribe(ad)

char* ad;


{
FILE *hdrIn,*bodIn;
char* t;
char buf[MAXLINE];

hdrIn = fopen("hdrbuf","r");
bodIn = fopen("bodbuf","r");

if (hdrIn == NULL || bodIn == NULL) {
	printf("Can't find previous message.\n");
	exit(1);
}

while (TRUE) {
	t = fgets(buf,MAXLINE,hdrIn);
        if (t == NULL)
                break;
	if (strncmp(buf,"-*-",3) == 0) {
		strcpy(theFrom,buf+3);
		*(theFrom + strlen(theFrom) - 1) = '\0';
		/*get rid of the carriage return*/
	}
	else
		putline(buf);
}

putline(ad);
putline("\n\0");

while (TRUE) {
	t = fgets(buf,MAXLINE,bodIn);
        if (t == NULL)
                break;
	putline(buf);
}

fclose(hdrIn);
fclose(bodIn);
}


putline(s)

char s[];
{

if (chrCnt + strlen(s) > BUFSZE) {
	ptrCnt++;
	chrCnt = 0;
	bufPtrs[ptrCnt] = (char*) malloc(BUFSZE * sizeof(char));
	if (bufPtrs[ptrCnt] == NULL) {
		printf("Out of memory.\n\n");
		exit(1);
	}
	*bufPtrs[ptrCnt] = '\0';
}

chrCnt+=strlen(s);
strcat(bufPtrs[ptrCnt],s);
}


writePipe() {

FILE *popen(),*fpOut;
char sndMl[250];
int lp;


sprintf(sndMl,"sendmail -f %s -t-oem-oi-om\n",theFrom);
fpOut = popen(sndMl,"w");

for(lp=0;lp<=ptrCnt;lp++) 
	fprintf(fpOut,"%s",bufPtrs[lp]);

pclose(fpOut);
exit(0);

}
